/**
 * ===========================================================================
 *                     Backtracking: DISPOSITIONS 
 * A disposition is a sequence of length D whose elements (not necessarily
 * distinct) are taken from a set of B elements.
 * ===========================================================================
 */

public class Dispositions {
 private int id = 0;
 private final int  D = 3;
 private final int  B = 2;
 private int[] array = new int[D];

 private void printar(int[] array, int size) {
   for (int k=0; k<size; k++) {System.out.print(array[k]+" ");}
   System.out.println();
  }

 private void generate() {
    int ib=1;
    do {array[id]=ib; id++;
        if (id==D) {printar(array,D);} else generate();
        id--;
        ib++;}
    while (ib<=B);
  }

 public static void main(String[] args) {

   Dispositions disp = new Dispositions();
   disp.generate();
 }
}

/**
 * input:                   output:
 * ---------------------------------------------------------------------------
 * javac Dispositions.java
 * java  Dispositions
 *                          1 1 1
 *                          1 1 2
 *                          1 2 1
 *                          1 2 2
 *                          2 1 1
 *                          2 1 2
 *                          2 2 1
 *                          2 2 2
 * ---------------------------------------------------------------------------
 */
