/**
 * ===========================================================================
 *                       Backtracking: PERMUTATIONS
 * Permutations are dispositions of D elements in groups of cardinality D.
 * Order is significant. Repetitions are not allowed.
 * For 1<=ib<=D, arrayE[ib-1] is true iff ib is in the vector arrayA.
 * ============================================================================
 */

public class Permutations {
 private int id = 0;
 private final int  D = 3;                  // D should be positive
 private      int[] arrayA = new int[D];    // by default: initially 0
 private  boolean[] arrayE = new boolean[D];// by default: initially false

 private void printar(int[] arrayA, int size) {
    for (int k=0; k<size; k++) {System.out.print(arrayA[k]+" ");}
    System.out.println();}

 private void generate() {
    int ib = 1;
    do {if (arrayE[ib-1] == false)
           {arrayA[id] = ib; arrayE[ib-1] = true; id++;
           if (id == D) {printar(arrayA,D);} else generate();
           id--; arrayE[ib-1] = false;};
        ib++;}
    while (ib<=D);
  }

 public static void main(String[] args) {

   Permutations perm = new Permutations();
   perm.printar(perm.arrayA,perm.D);
   System.out.println();
   perm.generate();
 }
}

/**
 * input:                   output:
 * ---------------------------------------------------------------------------
 * javac Permutations.java
 * java  Permutations
 *                          0 0 0
 *
 *                          1 2 3
 *                          1 3 2
 *                          2 1 3
 *                          2 3 1
 *                          3 1 2
 *                          3 2 1
 * ---------------------------------------------------------------------------
 */
