/**
 * ===========================================================================
 *                       Backtracking: n QUEENS
 * From: E.W. Dijkstra: 'A Short Introduction to the Art of Programming'.
 *       EWD 316 August 1971.
 * call as: java Queens n (n should be at least 1)
 * queens are placed from top to bottom, one for each row.
 * 
============================================================================
 */
public class Queens {
 int nq = 0;      // index of queen to be placed in the current solution.
                  // See generate().
 int nqueens, nqueens1;
 int[] arrayQ;
 boolean[] col, up, down;

 Queens(int[] arrayQ, boolean[] col, boolean[] up, 
        boolean[] down, int nqueens) {     // constructor of the class nQueens
     this.nqueens  = nqueens;
     this.nqueens1 = nqueens-1;
     this.arrayQ   = arrayQ;
     this.col      = col;
     this.up       = up;
     this.down     = down;
    }
/** --------------------------------------------------------------------------
 * In Dijkstra: up is an array [-(nqueens-1)..nqueens-1] of booleans.
 * We have indicated the indexes he used in the comments below:  // up[...].
 * We increased Dijkstra's indexes by nquees1, which is nqueens-1.
 * ---------------------------------------------------------------------------
 */
 private void printar(int[] arrayA, int size) {
    for (int k=0; k<size; k++) {System.out.print(arrayA[k]+" ");}
                                System.out.println();}

 private void generate()
    {int h=0;
    do {if (!(col[h] || up[nq-h+nqueens1] || down[nq+h]))        // up[nq-h]
           {arrayQ[nq]=h; col[h]=true; up[nq-h+nqueens1]=true;   // up[nq-h]
            down[nq+h]=true; nq=nq+1;
            if (nq==nqueens) {printar(arrayQ,nqueens);} else generate();
            nq=nq-1;col[h]=false; up[nq-h+nqueens1]=false;       // up[nq-h]
            down[nq+h]=false;};
        h=h+1;}
    while (h!=nqueens);}
//----------------------------------------------------------------------------
 public static void main(String[] args) {

      int m=0;      // m is the number of queens. See the field: nqueens
      try {m = Integer.parseInt(args[0]);
      } catch (Exception e) {
           System.out.print("Number of queens should be >= 1.");
           System.out.println(" By default we assume 1 queen only.");
           m=1;
      }
 System.out.println("Number of queens = "+m);
 int[]     arrayQ = new int[m];         // integer array [0..m-1]
 boolean[] col    = new boolean[m];     // boolean array [0..m-1]
 boolean[] up     = new boolean[2*m-1]; // boolean array [0..2(m-1)]
 boolean[] down   = new boolean[2*m-1]; // boolean array [0..2(m-1)]

 Queens queens = new Queens(arrayQ, col, up, down, m);//
 queens.generate();
 }
}

/**
 * input:            output:
 * ---------------------------------------------------------------------------
 * javac Queens.java
 * Java  Queens
 *                   Number of queens = 6
 *                   1  3  5  0  2  4
 *                   2  5  1  4  0  3
 *                   3  0  4  1  5  2
 *                   4  2  0  5  3  1
 * ---------------------------------------------------------------------------
 */
