/**
 * ==========================================================================
 *                 Monitor class for a Bounded Buffer 
 *
 * It is called by the method ProducerConsumerMonitorMain
 *
 * The commands with  // statement for tracing 
 * make visible the insertiona and deletion of elements in the buffer.
 * ==========================================================================
 */

public class BoundedBufferMonitor {
   private final int N = 3;  // size of buffer
   private float [] buffer = new float[N];
   private int in = 0, out = 0, count = 0;

   public synchronized void put(float value) {
      while (count == N)
         try {wait();
         } catch (InterruptedException e){};
      buffer[in] = value;
      System.out.println("-> " + value);          // statement for tracing 
      in = (in + 1) % N;
      count++;
      notify();
   }

   public synchronized float get() {
      float value;
      while (count == 0) 
         try {wait();
         } catch (InterruptedException e){};
      value = buffer[out];
      System.out.println("   " + value + " ->"); // statement for tracing 
      out = (out + 1) % N;
      count--;
      notify();
      return value;
   }
}
