/**
 * ===========================================================================
 *                     CounterThread2    
 *
 * It uses the class UpCounter (or UpCounterLocal).
 * ===========================================================================
 */
import Counter.*;

public class CounterThread2 extends UpCounter implements Runnable { // --- (1)
                                 //
                                 // UpCounterLocal (see comments below)
   final int N=3;

   public CounterThread2(int n){ // constructor
      super(n);
   }

   public void run(){
      System.out.println(N + " values of the counter:");
      for (int i=0; i<N; i++) {
           System.out.println("  " + (getValue()));
           int v = getValue() + 1; 
           setValue(v); 
      }
   }

   public static void main(String [] args){
      CounterThread2 c1 = new CounterThread2(10);
      Thread tc1 = new Thread(c1);
      tc1.start();
      try {
          tc1.join(); 
      } catch (InterruptedException e) {};

      c1.up();    
      c1.up(); 
      int v = c1.getValue();  

      CounterThread2 c2 = new CounterThread2(v);
      Thread tc2 = new Thread(c2);
      tc2.start();
   }
}
/** input:                    output:
 * ---------------------------------------------------------------------------
 *  javac CounterThread2.java
 *  java  CounterThread2
 *                            3 values of the counter:
 *                              10
 *                              11
 *                              12
 *                            3 values of the counter:
 *                              15
 *                              16
 *                              17
 * ---------------------------------------------------------------------------
 *  If in line (1) we write UpCounterLocal, instead of UpCounter, we have:
 *
 *  javac CounterThread2.java
 *  java  CounterThread2
 *                            3 values of the counter:
 *                              10
 *                              11
 *                              12
 *                            3 values of the counter:
 *                              13
 *                              14
 *                              15
 * ---------------------------------------------------------------------------
 */
