/**
 * ===========================================================================
 *                CONCURRENT MERGESORT
 *
 * It randomly generates an array of n elements to be sorted.
 * n should be >= 1. If n is not supplied, then we assume that n=20. 
 *
 * It uses MergeSortThread and Maximum. Thanks to Prof. Marco Danelutto.
 * ===========================================================================
 */
import java.util.Random;
import Maximum.*;

public class ConcurMergeSort {

    public static void main (String[] args) {

        int n; final int MAX = 80;
        try {
            n = Integer.parseInt(args[0]);
        } catch (Exception e) {
        System.out.print("\nType: java ConcurMergeSort n (with n>=1). ");
        System.out.print("Now we have assumed n=20.\n");
            n = 20;
        }
                       // constructing an array of n elements
        int[] arrayA = new int [n];

                       // initializing the array with random integers
        Random generator = new Random();
        for(int i=0;i<n;i++)
            arrayA[i] = generator.nextInt(MAX);

                      // printing the initial array
        System.out.println();
        for(int i=0;i<n;i++) System.out.print(arrayA[i]+" ");
        System.out.println("\n");

        Maximum max = new Maximum();

                      // the initial thread is "go"
        Thread go = new MergeSortThread(arrayA,0,n-1,max);
        go.start();
                      // waiting the end of initial thread
        try {
            go.join();
        } catch(InterruptedException e) {}

                      // printing the ordered array
        for(int i=0;i<n;i++) System.out.print(arrayA[i]+" ");

                       // printing the maximum number of active threads
        System.out.print("\n\nAt most "+max.get());
        System.out.println(" threads active at the same time.");
        }
}
/** 
 * input:         output:
 * --------------------------------------------------------------------
 * javac ConcurMergeSort.java
 * java  ConcurMergeSort 15
 * 
 *                13 0 18 60 18 53 15 26 38 74 5 33 31 64 9
 * 
 *                0 5 9 13 15 18 18 26 31 33 38 53 60 64 74
 * 
 *                At most 17 threads active at the same time.
 * --------------------------------------------------------------------
 */
