/**
 * ===========================================================================
 *                  Mergesort with Threads
 * 
 * It is called by ConcurMergeSort. 
 * It uses the class Maximum of the package Maximum.
 * ===========================================================================
 */

import Maximum.Maximum;
public class MergeSortThread extends Thread {

    private int [] arrayZ;
    private int az,bz;
    private Maximum max;

    MergeSortThread(int [] arrayZ, int az, int bz, Maximum m) {
        this.arrayZ = arrayZ;           // fields initialization
        this.az = az;
        this.bz = bz;
        this.max = m;
    }

    public void run() {
        max.update(this.activeCount()); // counting the current active threads

        if((bz-az) > 0) {
             int m1 = ((bz-az+1)/2);
             int m2 = ((bz-az+1)-m1);
             int [] arrayX = new int [m1];
             int [] arrayY = new int [m2];
             for (int i=0; i<=m1-1; i++) {arrayX[i] = arrayZ[az+i];};
             for (int i=0; i<=m2-1; i++) {arrayY[i] = arrayZ[az+m1+i];};

             Thread leftSort  = new MergeSortThread(arrayX,0,m1-1,max);
             Thread rightSort = new MergeSortThread(arrayY,0,m2-1,max);
                leftSort.start();
                rightSort.start();
             try {
                  leftSort.join();
                  rightSort.join();
             } catch (InterruptedException e) {};

             merge(0,m1-1,0,m2-1,az,bz,arrayX,arrayY,arrayZ);
          }
    }

    private void merge(int ax, int bx, int ay, int by, int az, int bz,
                       int[] arrayX, int[] arrayY, int[] arrayZ) {
        int kx = ax; 
        int ky = ay; 
        int kz = az; 
        boolean b;
        while (kz <= bz) {
            if (ky > by) {b = true; } else
            if (kx > bx) {b = false;} else {b = (arrayX[kx] <= arrayY[ky]);};

            if (b) {arrayZ[kz] = arrayX[kx]; kx++; kz++;} else
                   {arrayZ[kz] = arrayY[ky]; ky++; kz++;};
            };
    }
}
