/**
 * ===========================================================================
 *                  Quicksort with Threads
 * 
 * It uses the class Maximum.
 * ===========================================================================
 */

import Maximum.Maximum;

public class QuickSortThread extends Thread {

    private int[] array;
    private int a;
    private int b;
    private Maximum max;

    public QuickSortThread(int [] array, int a, int b, Maximum m) {
        this.array = array;             // fields initialization
        this.a     = a;
        this.b     = b;
        this.max   = m;
    }

    public void run() {
        max.update(this.activeCount()); // counting the current active threads

        if(a<b) {
            if (array[a] > array[b]) {
                int temp = array[a]; 
                array[a] = array[b]; 
                array[b] = temp;
            };

            int r            = (array[a]+array[b])/2;
            int cut          = Partition(array,a+1,b-1,r);

            Thread leftSort  = new QuickSortThread(array,a,cut-1,max);
            Thread rightSort = new QuickSortThread(array,cut,b,max);
            leftSort.start();
            rightSort.start();
            try {
                leftSort.join();
                rightSort.join();
            } catch (InterruptedException e) {}
        }
    }

    private int Partition(int[] array, int a, int b, int r) {
       int c = a; 
       int d = b;
       while (c <= d) {
          if (array[c] <= r) {
              c++;
          } else if (array[d] > r) {
              d--;
          } else {
              int temp = array[c]; 
              array[c] = array[d]; 
              array[d] = temp;
              c++; 
              d--;
          }
       }
       return(c);
    }
}
