/**
 * ===========================================================================
 *          Class which constructs a binary node with two son nodes
 * ===========================================================================
 */
package parser;
import parserUtil.Node;

public class BinaryNode extends Node {

  /**
   * @param v : value at the node
   * @param l : left son node
   * @param r : rightson node
   */
   public BinaryNode(Object v, Node l, Node r) {  // constructor
      super(v, l, r);
   }
  /**
   * @return a string representing the tree whose root is the given node
   */
   public String toString(){
      return "("+ left.toString() +"."+ value +"."+ right.toString() +")";
   }
   /**
    * @return the left son node
    * This method overrides the one of the class Node     
    */
   public Node getLeftChild(){
        return left;
   }
   /**
    * @return the right son node
    * This method overrides the one of the class Node
    */
   public Node getRightChild(){
        return right;
   }
}
