/**
 * ===========================================================================
 *                           TreeStack class
 * This class constructs a stack of nodes (i.e., trees). It is realized by
 * using the class Stack and the class Node of the package parserUtil.
 * ===========================================================================
 */
package parser;
import  parserUtil.Stack;
import  parserUtil.Node;

public class TreeStack {
	
   Stack stack;                    // field
   public TreeStack(){             // constructor
      stack = new Stack();
   }
    /**
     * @param node : the node to be inserted at the top of the stack
     * @return the tree inserted at the top of the stack
     */
   public Node push(Node node){
      return (Node)stack.push(node);
   }
    /**
     * @return the tree at the top of the stack and pops it
     */
   public Node pop(){
      return (Node)stack.pop();
   }
    /**
     * @return the tree at the top of the stack without popping it
     */
   public Node top(){
      return (Node)stack.peek();
   }
    /**
     * @return true if the stack is empty
     */
   public boolean isEmpty(){
      return stack.isEmpty();
   }	
}
