/**
 * ===========================================================================
 *            Class which constructs a unary node with one son node
 * ===========================================================================
 */
package parser;
import parserUtil.Node;

public class UnaryNode extends Node {             // constructor

    /**
     * @param v   : value at the node
     * @param son : son node
     */

     public UnaryNode(Object v, Node son) {
          super(v, son);
     }
     /**
       * @return a string representing the tree whose root is the given node
       */
     public String toString() {
          return "(" + value + "." + getChild().toString() + ")";
     }
     /**
      * @return the son node
      * This method overrides the one of the class Node
      */
     public Node getChild() {
          return left;
     }
}
