/**
 * ===========================================================================
 *                       Monitor for forks
 *
 * We assume that there are n forks (with n>=2).
 * The i-th philosopher has two operations: takeforks(i) and releaseforks(i) 
 * ===========================================================================
 */
public class ForkMonitor implements Resource {
   private int n = 0;
   private boolean [] freefork;

   public ForkMonitor(int n) {
      this.n = n;
      this.freefork = new boolean[n];
      for (int i = 0; i < n; i++)
         this.freefork[i] = true;
   }

   public synchronized void takeforks(int i) {
      while (freefork[i] == false)
         try { wait();                   // availablefork[i].wait;
         } catch (InterruptedException e){};
      freefork[i] = false;
      while (freefork[(i + 1) % n] == false)
         try { wait();                   // availablefork[(i+1) % n].wait;
         } catch (InterruptedException e){};
      freefork[(i + 1) % n] = false;
   }

   public synchronized void releaseforks(int i) {
      freefork[i] = true;
      notify();                          // availablefork[i].signal;
      freefork[(i + 1) % n] = true;
      notify();                          // availablefork[(i + 1) % n].signal;
   }
}
