/**
 * ===========================================================================
 *                       Five Philosophers: Main 
 *
 * N=5. It works for N philosophers with N >= 2.
 * call as: java Philosopher
 * ===========================================================================
 */

public class Philosopher implements Runnable {
   int id = 0;
   Resource r = null;

   public Philosopher(int id, Resource r) {
      this.id = id;
      this.r = r;
      new Thread(this).start();
   }

   public void run() {
      while (true) {
        try {
        Thread.sleep(15 + 20*id);     // thinking   (***)
        r.takeforks(id);

        System.out.print(id + "   "); // id : the eating philosopher
        Thread.sleep(6);              // eating

        r.releaseforks(id);
        } catch (InterruptedException e) {}
      }
   }

   public static void main(String[] args) {
      final int N = 5;                //  N should be >= 2.
      ForkMonitor fm = new ForkMonitor(N);
      for (int i = 0; i < N; i++)
         new Philosopher(i, fm);
   }
}

/**
 *  The output shows the philosopher who is eating.
 *  The thinking time is proportional to the philosopher identity (see ***)
 *  input:    output:
 * ---------------------------------------------------------------------------
 *            0   1   2   0   3   4   1   0   2   0   3   1   0   2   4   ...
 * ---------------------------------------------------------------------------
 */
