/**
 * ===========================================================================
 *                           ArrayClass.
 * This class is required by ConcurLinearFibonacci and FibThread.
 * ===========================================================================
 */

public class ArrayClass {
  /**
   * This class constructs an object which has the array arrayA of d elements.
   * This object has three operations:
   * - printar(), for printing the array,
   * - setValue(int index, int value), for updating an element of the array,
   * - getValue(int index), for reading an element of the array.
   */
    private static int [] arrayA;         // data fields: arrayA
    private static int dim;               //              dim
                                      
    ArrayClass(int d) {            // constructor
        this.arrayA = new int [d]; 
        for(int i=0; i<d; i++) {   // initialization of arrayA 
          this.arrayA[i] = -1;     // all elements of arrayA are set to -1     


          };
        this.dim = d;              // initialization of dim
    }

    public static void printar() {
        for (int k=0; k<dim; k++) {
            System.out.print(arrayA[k] + " ");
        }
        System.out.println();
    }

    public synchronized void setValue(int index, int value) {
     // System.out.println("New fibonacci number ["+ index +"] = "+value); //
        arrayA[index] = value;
        notifyAll();
     // printar(); // each time an element is added the arrayA is printed  //
        return;
    }

    public synchronized int getValue(int index) {
     // System.out.println("fib(" + index +")=" + arrayA[index]);          //
        while (arrayA[index] == -1) {
            try {
                wait();
            } catch (InterruptedException e) {}
        }
        return(arrayA[index]);
    }
}
