/**
 * ===========================================================================
 *                         Class FibThread
 * This class constructs threads: t[0], ..., t[n], for computing fibonacci(n).
 * n should be a non-negative integer.
 * It has the static array memo which is an object of the class ArrayClass.
 * This class Thread is required by ConcurLinearFibonacci.
 * ===========================================================================
 */
public class FibThread extends Thread {
  /**
   * This class constructs threads which cooperate for the computation of
   *   fibonacci(n).
   * - It will construct n+1 threads (see the main method in
   *   ConcurLinearFibonacci.java)
   * - There exists one copy only of the array memo which has n+1 elements
   *   and that copy is shared among the n+1 threads.
   * Lines (1), (2), and (3) may be uncommented if one wants to see
   * the beginning and the end of the threads.
   */                                      // private data fields:
    private static ArrayClass memo;        //          static array memo 
    private int ind;                       //          ind
                                        
    FibThread(ArrayClass arrA, int i) {    // constructor 
        this.memo = arrA;                  // initialization of memo 
        this.ind = i;                      // initialization of ind
    }

    public void run() {
        // setName((new Integer(ind)).toString());               //  (1)
        // System.out.println("Thread "+ getName() + ": begin"); //  (2)
        if (ind == 0) {
             memo.setValue(0,0);
        } else if (ind == 1) {
             memo.setValue(1,1);
        } else {
             int value = memo.getValue(ind-2) + memo.getValue(ind-1);
             memo.setValue(ind,value);
        }
        // System.out.println("Thread "+ getName() + ": end");   //  (3)  
        return;
    }
}
