/**
 * ===========================================================================
 *                     A Bank Account Specification
 *
 * This interface is implemented by the class BankAccount.
 * This interface is stored in the file named: BankAccountSpecification.java
 * Thanks to David Schmidt. Changes by Alberto Pettorossi.
 * ===========================================================================
 */

 public interface BankAccountSpecification {
   public boolean deposit  ( int amount );
   public boolean withdraw ( int amount );
 }
// ---------------------------------------------------------------------------
/**
 * Here is a UML diagram for the interface BankAccountSpecification and the
 * two classes BankAccount and MortgagePaymentCalculator:
 *
 *                              ._._._._._._._._._._._._._._.
 *                              |                           |
 *                              |      <<interface>>        |
 *                              |                           |
 *                              | BankAccountSpecification  |
 *                              |._._._._._._._._._._._._._.|
 *                                 .                 .
 *                   (open head)  /|\               /_\  (triangle head) 
 *                                 |                 |
 *   depends on an object of       |                 | 
 *   a class which implements /    |                 | implements
 *   has as argument an object of  |                 |   
 *   a class which implements      |                 |
 *                                 |                 |
 *                 (dashed line)   |                 |   (dashed line)
 *                                 |                 |
 *              ------------------------------   ---------------
 *              |          class:            |   |    class:   |
 *              | MortgagePaymentsCalculator |   | BankAccount |
 *              ------------------------------   ---------------
 *
 * ---------------------------------------------------------------------------
 */
