/**
 * ===========================================================================
 *                  Preliminary Program: STRINGS
 * 
 * call as: 
 * java  Strings xx, where xx is a sequence of characters (no single quotes)
 * ===========================================================================
 */

public class Strings {
   /** This class does not construct any object. It has the static method 
    *  main only.
    */

public static void main(String[] args) {
    String inp = "01234";
    String ft = inp.substring(0,2);       // taking substrings
    System.out.println(ft);
    System.out.println("abcdefghi");
    System.out.println("abcd\te\r++");    // \t is a tab character
                                          // \r is return in the same line
    ft = inp.substring(1,inp.length());   // taking substrings
    System.out.println(ft);
/** 
 * From String to Integer to int.
 * The wrapper class Integer produces the object Integer(inp) of type
 * Integer from the string inp, and then
 * the method intValue() produces an int i from Integer(inp).
 */
    int i = new Integer(inp).intValue();  

    System.out.println(i * 10);
    int j = 567;                          // from int to string
    String sj = j + "a";
                                          // use of charAt(...)
    System.out.println(sj + sj.charAt(2));

    System.out.println((char)('f' + 1));  // arithmetics on characters
    sj = args[0];                         // input of main: 7654
    System.out.println(sj);

    String s = ""; 
    int n = 5;

    for (i=0; i<n; i++)
    { s += "# " + i; }
    System.out.println(s);

    int v = 7;
/**
 *  + makes a conversion from int to string:
 *  s + v is the same as: s.concat(Integer.toString(v)) for any v of type int
 *  The equality of strings == is different from equals(...)
 *
 *  Notice the object-oriented approach: the binary operator + is equivalent
 *  to the invocation of the method concat(...) of the object s. 
 *  The second operand of + is given as the argument of concat(...).
 */
    if ((s + v) == s.concat(Integer.toString(v))) 
         {System.out.println("true");}
    else {System.out.println("false");};  // result is: false.  
   
    // (s + v) == s.concat(Integer.toString(v) are not identical objects.    

    if ((s + v).equals(s.concat(Integer.toString(v)))) 
         {System.out.println("true");}
    else {System.out.println("false");}   // result is: true 

    // (s + v) == s.concat(Integer.toString(v) are the same sequences of
    //                                         characters. 
    s = "1";
    if ( ((s).compareTo(s + "2") < 0) ) 
         {System.out.println(s + " is \"smaller than\" "     + s + "2");}
    else {System.out.println(s + " is NOT \"smaller than\" " + s + "2");} 
    }
}
/**
 * input:                output:
 * ---------------------------------------------------------------------------
 * javac Strings.java
 * java  Strings 7654
 *                       01
 *                       abcdefghi
 *                       ++cd    e
 *                       1234
 *                       12340
 *                       567a7
 *                       g
 *                       7654
 *                       # 0# 1# 2# 3# 4
 *                       false
 *                       true
 *                       1 is "smaller than" 12
 * --------------------------------------------------------------------------
 */
