/**
 * ===========================================================================
 *               Elementary Graphics: TIME CONVERTOR
 * twelveHourClock  converts a 24-hour-clock time into a 12-hour-clock time.
 * @param hour   - the hour time, in the range 0..23
 * @param minute - the minutes time, in the range 0..59
 * @return the 12-hour-clock time, formatted as a string.
 * Thanks to David Schmidt.   
 * ===========================================================================
 */
import javax.swing.*;
public class TimeConvertor {

  /** Using the class TimeConvertor we can construct an object
   *  which has the method twelveHourClock which takes two int values,
   *  one for the hours and one for the minutes, and returns a string
   *  answer. Finally, this string is displayed by the method
   *  showMessageDialog(null, "Time is " + answer).
   */

 public String twelveHourClock(int hour, int minute) {
  String answer = "";  // accumulates the formatted time, symbol by symbol
                       // answer is a local variable. 
                       // It is different from answer in the main method.
  if ( hour < 0  ||  hour > 23  ||  minute < 0  ||  minute > 59 )
       { answer = "twelveHourClock input error !! " + hour + "." + minute; }
  else { if ( hour >= 13 )        // hours 13..23 are reduced by 12
                                  // numbers are considered as strings
              { answer = answer + String.valueOf(hour - 12); } 
         else { if ( hour == 0 )  // hour 0 is written as 12
                     { answer = answer + "12"; } 
                else { answer = answer + hour; }
              }
         answer = answer + ":";
         if ( minute < 10 )       // display minutes  0..9  as  00..09
            { answer = answer + "0"; }
         answer = answer + minute;
         if ( hour < 12 )         // morning or afternoon?
              { answer = answer + " a.m."; }
         else { answer = answer + " p.m."; }
       }
  return answer;
}

 public static void main(String[] args) {
   TimeConvertor timeConv = new TimeConvertor();  
   String input = JOptionPane.showInputDialog
              ("Either type hours in range 0..23 and click OK \nor Cancel:");
   if ( input == null )         // no hours in input: the user pressed Cancel
        { JOptionPane.showMessageDialog(null, "Request cancelled"); }
   else { int hours   = new Integer(input).intValue();
          input = JOptionPane.showInputDialog
              ("Either type minutes in range 0..59 and click OK \nor Cancel:");
          if ( input == null )  // no minutes in input: the user pressed Cancel
               { JOptionPane.showMessageDialog(null, "Request cancelled"); }
          else {int minutes = new Integer(input).intValue(); 
                String answer = timeConv.twelveHourClock(hours, minutes);
                JOptionPane.showMessageDialog(null, "Time is " + answer);
               }
        }
  }
}
/**
 * input:                         output:
 * ---------------------------------------------------------------------------
 * javac TimeConvertor.java
 * Java  TimeConvertor
 *                                (see figures below)
 * ---------------------------------------------------------------------------
 */
