/**
 * ===========================================================================
 * This class manipulates the queue storing the sums of the rows.
 * ===========================================================================
 */
import java.util.*; // required for LinkedList

public class SumQueue {
  
  LinkedList queue = new LinkedList();
  int n = 0; 

  SumQueue(int n) {
    this.n = n;     // number of sums to compute
  }

  public synchronized void put(int i) {
    queue.addLast(new Integer(i));
    n--;
    notify();       // we have one consumer only. notify() is enough
    }

  public synchronized int get() throws Exception {
    while ((queue.size() == 0 && n!=0)) {
      try {
      wait();       // wait if more partial sums are expected
      } catch (InterruptedException e) {}
    }
    if (n == 0  &&  queue.size() == 0)
      throw new Exception("Work ended!");
    else
      return(((Integer) (queue.removeFirst())).intValue());
  }
}
