  public interface Comparable {
     public int compareTo (Object obj); 
  } 

/**
 * ---------------------------------------------------------------------------
 * We could have omitted the modifier "public" for the method compareTo.
 * Implicitly all methods of interfaces have the modifiers "abstract public".
 *
 * The call to the method compareTo is as follows:
 *      object1.compareTo(object2)
 *
 * If object1 < object2 then the returned int is -1 
 *            =                                   0
 *            >                                  +1
 *
 * If the objects of a class need to be compared, that class should implement
 * the Comparable interface, that is, in the class we should define a 
 * compareTo(...) method.
 * ---------------------------------------------------------------------------
 */                                
