/**
 * ===========================================================================
 *                   Iteration: FACTORIAL
 *
 * factorial(n) computes  n!  for n in the range 0..20.
 * Note: for n < 0,  factorial(n) makes no sense, and
 *       for n > 20, factorial(n) is too large for Java to compute.
 * ===========================================================================
 */
public class IterativeFactorial {
   /** 
    * The method main iteratively computes n! 
    * @param n - the input value. n should be in the range 0..20.
    * The method main throws a RuntimeException if n < 0  or  n > 20. 
    */
 public static void main(String[] args) {

   long answer = 1;                               // 0! = 1

   long n = Integer.parseInt(args[0]);
   if ( n < 0  ||  n > 20 )
        { throw new RuntimeException("\nfactorial error: illegal input"); }
   else {
         for (int i=2; i<=n; i++)                 // 1! = 1
             { answer = answer * i; }             // Iteration
        };

   System.out.println(answer);
   }
}
/**
 * input:                         output:
 * ---------------------------------------------------------------------------
 * javac IterativeFactorial.java
 * java  IterativeFactorial 5
 *                                120
 * ---------------------------------------------------------------------------
 */
