/**
 * ===========================================================================
 *              Iteration: COMPUTING THE FIBONACCI NUMBERS 
 * 
 * It computes the Fibonacci numbers up to a given index.
 *
 * fibArr[i] contains the i-th Fibonacci number
 *
 *    index i:           0, 1, 2, 3, 4, 5, 6,  7, ...
 *    fibonacci number:  0, 1, 1, 2, 3, 5, 8, 13, ...
 *
 * call as: java IterativeFibonacci n (with n >= 0)
 * ===========================================================================
 */
public class IterativeFibonacci {  
    /** The class IterativeFibonacci has two static methods only:
     *  - printar(arrA, size), for printing the array arrA whose size is 
     *    the value of the second parameter called size, and  
     *  - main, for executing the main program.
     *  No objects of the class IterativeFibonacci are constructed.
     */
    public static void printar(int[] arrA, int size) {
        for (int k=0; k<size; k++) {System.out.print(arrA[k]+" ");}
        System.out.println();
        }

    public static void main(String [] args) {
        int [] fibArr;
        int n;

        try {
            n = Integer.parseInt(args[0]);
        } catch (Exception e) {
            System.out.println("Please, type: java IterativeFibonacci n");
            System.out.println("(with n >= 0)");
            return;
        }

        fibArr = new int [n+1];  
        for(int i=0; i<=n; i++) 
           {if (i==0) fibArr[i] = 0; else 
            if (i==1) fibArr[i] = 1; else
            fibArr[i] = fibArr[i-1] + fibArr[i-2];
           };      
        printar(fibArr,n+1);
        System.out.println("fib(" + n + ") = " + fibArr[n]);
    }
}
/** input:                         output:
 * ---------------------------------------------------------------------------
 *  javac IterativeFibonacci.java   
 *  java  IterativeFibonacci 11
 *                                 0 1 1 2 3 5 8 13 21 34 55 89 
 *                                 fib(11) = 89 
 * ---------------------------------------------------------------------------
 */