/**
 * ===========================================================================
 *                   Recursion: FACTORIAL
 *
 * factorial(n) computes  n!  for n in the range 0..20.
 * Note: for n < 0,  factorial(n) makes no sense, and
 *       for n > 20, factorial(n) is too large for Java to compute.
 * ===========================================================================
 */

public class RecFactorial {
   /** 
    * The method factorial(n) recursively computes n! 
    * @param n the input value. n should be in the range 0..20.
    *  The method factorial(n) throws a RuntimeException if n<0 or n>20.
    * @return answer - which is equal to n! 
    *  
    */

 public long factorial(long n) {

    long answer;          // answer is a local variable. 
                          // It is different from answer in the main method.
    if ( n < 0  ||  n > 20 )
         { throw new RuntimeException("factorial error: illegal input"); }
    else { if ( n == 0 )
                { answer = 1; }                    // 0! = 1
           else { answer = n * factorial(n - 1); } // (n+1)! = (n+1) * n!
         }
    return answer;
  }

 public static void main(String[] args) {
   RecFactorial fact = new RecFactorial(); 
                          // fact is an object of the class RecFactorial.
                          // fact has the method factorial(long n)

   long n      = Integer.parseInt(args[0]);
   long answer = fact.factorial(n);
        System.out.println(answer);
   }
}

/**
 * input:                   output:
 * ---------------------------------------------------------------------------
 * javac RecFactorial.java
 * java  RecFactorial 5
 *                          120
 * ---------------------------------------------------------------------------
 */
