/**
 * ==========================================================================
 *                   Recursion: FIBONACCI NUMBERS
 * This program computes  the n-th fibonacci number in the range 0..35.
 * (Note: answers for  n > 35  are too large for Java to compute,
 *  and   answers for  n < 0   make no sense.)
 * 
 * call as: java RecFibonacci n (with 0 =< n =< 35)
 * ==========================================================================
 */

public class RecFibonacci {

 /** Using the class RecFibonacci we can construct an object which has 
  *  a method, called fibonacci(n), which recursively computes the value of 
  *  the n-th fibonacci number.   
  */

 public static long fibonacci(int n) {
    long answer;
    if ( n < 0  ||  n > 35 ) {
         throw new RuntimeException("\nfibonacci error: illegal input"); 
    }
    else { 
        if (n == 0) { 
            answer = 0;    // fibonacci(0) = 0
        }          
        else if (n == 1) { 
            answer = 1;    // fibonacci(1) = 1
        }   
        else {             // fibonacci(n+2) = fibonacci(n+1) + fibonacci(n)
            answer = fibonacci(n-1) + fibonacci(n-2);
        }
    }
    return answer;
  }

 public static void main(String[] args) {
   try{
      int n            = Integer.parseInt(args[0]);
      RecFibonacci fib = new RecFibonacci();
      System.out.println(fib.fibonacci(n));
   } catch(NumberFormatException nex) {
      System.out.println("Fibonacci error: not a number in input!");
   }
 }
}
/* input:                  output:
 * --------------------------------------------------------------------
 * javac RecFibonacci.java
 * java  RecFibonacci 6  
 *                         8
 * --------------------------------------------------------------------
 */
