/**
 * ==========================================================================
 *                  Peterson's Algorithm (for two processes only)
 *
 * The two processes are: P_0 and P_1.
 * The indexes i and j which occur in the methods 
 *    takeLock(int i)    and 
 *    releaseLock(int i) 
 * belong to the set {0,1}.
 *
 * This class implements the interface Lock.
 * ==========================================================================
 */

public class PetersonTwoProcesses implements Lock {
   boolean [] q = {false,false};
   int s = 1;

    public void takeLock(int i){     // entry protocol
     int j = 1-i;
     q[i] = true;
     s = i;
     while (q[j] && (s != j));
    }

    public void releaseLock(int i) { // exit protocol
     q[i] = false;
    }
}

