/**
 * ==========================================================================
 *                  Class for testing a monitor for a queue 
 *
 * It uses the class QueueMonitor.java
 * ==========================================================================
 */
public class ConcurQueueTester extends Thread {

   QueueMonitor queue = null;
   Thread thread1;
   Thread thread2;
   final int DELAY = 10;

   public ConcurQueueTester(QueueMonitor queue){
      this.queue = queue;
      thread1 = new Thread(this);
      thread2 = new Thread(this);
      thread1.start();
      thread2.start();
   }

   public void run() {
      queue.print();
      queue.enqueue(7);
      queue.print();
      try {
            this.sleep(DELAY);
          } catch (InterruptedException e) {};
      queue.enqueue(8);
      queue.print();
     
      queue.dequeue();
      queue.print();
   }

   public static void main(String[] args) {
      QueueMonitor queue = new QueueMonitor();
      ConcurQueueTester concurQueueTester = new ConcurQueueTester(queue);
   }
}
/** 
 * input:                     output:
 * ---------------------------------------------------------------------------
 * javac ConcurQueueTester.java
 * java  ConcurQueueTester
 *                            queue: < <
 *                            queue: < 7 <
 *                            queue: < 7 <
 *                            queue: < 7 7 <
 *                            queue: < 7 7 8 <
 *                            queue: < 7 8 <
 *                            queue: < 7 8 8 <
 *                            queue: < 8 8 <
 * ---------------------------------------------------------------------------
 */
