/**
 * ==========================================================================
 *                  Monitor class for a Queue
 *
 * Thanks to Prof. Vijay K. Garg, Austin, Texas. 
 * ==========================================================================
 */
public class QueueMonitor {

        private class Element {
           private int datum;
           private Element next;
        }

        private Element first = null;
        private Element last  = null;
        
        public synchronized void enqueue(int datum) {
                Element newElement = new Element();
                newElement.datum = datum;
                newElement.next = null;
                if (last == null){
                        last = newElement;
                        first = newElement;
                } else {
                        last.next = newElement;
                        last = newElement;
                }
                notify();
        }

        public synchronized int dequeue() {
                while (first == null)
                   try {wait();
                   } catch (InterruptedException e){}
                int returnval = first.datum;
                first = first.next;
                return returnval;
        }

        public synchronized void print() {
                Element first1 = first;
                System.out.print("queue: < ");
                while (first1 != null) {
                   System.out.print(first1.datum + " ");
                   first1 = first1.next;
                };
                System.out.println("<");
        }
}
