/**
 * ==========================================================================
 *                  Class for testing a monitor for a stack 
 *
 * It uses the class StackMonitor.java
 * ==========================================================================
 */

public class ConcurStackTester extends Thread {

   StackMonitor stack = null;
   Thread thread1;
   Thread thread2;
   final int DELAY = 10;

   public ConcurStackTester(StackMonitor stack){
      this.stack   = stack;
      thread1 = new Thread(this);
      thread2 = new Thread(this);
      thread1.start();    
      thread2.start();
   }

   public void run() {   
      stack.print();
      stack.push(3);
      stack.print();
      try {
            this.sleep(DELAY);
          } catch (InterruptedException e) {};
      stack.push(4);
      stack.print();
      stack.pop();
      stack.print();
      stack.pop();
      stack.print();
   }

   public static void main(String[] args) {
      StackMonitor stack = new StackMonitor();
      ConcurStackTester concurStackTester = new ConcurStackTester(stack);
   }
}
/** 
 *  input:                 output:
 * ---------------------------------------------------------------------------
 * javac ConcurStackTester.java
 * java  ConcurStackTester
 *                         stack: < <
 *                         stack: < 3 <
 *                         stack: < 3 <
 *                         stack: < 3 3 <
 *                         stack: < 4 3 3 <
 *                         stack: < 3 3 <
 *                         stack: < 3 <
 *                         stack: < 4 3 <
 *                         stack: < 3 <
 *                         stack: < <
 * ---------------------------------------------------------------------------
 */
