/**
 * ==========================================================================
 *                  Monitor class for a Stack
 *
 * Thanks to Prof. Vijay K. Garg, Austin, Texas. 
 * ==========================================================================
 */

public class StackMonitor {

        private class Element {
           private int datum;
           private Element next;
        }

        private Element first = null;
        
        public synchronized void push(int datum) {
                Element newElement = new Element();
                newElement.datum = datum;
                newElement.next = first;
                first = newElement;
                notify();
        }

        public synchronized int pop() throws NullPointerException {
                int returnval = first.datum;
                first = first.next;
                return returnval;
        }

        public synchronized void print() {
                Element first1 = first;
                System.out.print("stack: < ");
                while (first1 != null) {
                   System.out.print(first1.datum + " ");
                   first1 = first1.next;
                };
                System.out.println("<");
        }
}
